/*
 * GWT - General Windowing Toolkit
 *
 * Copyright (C) 1998 MenTaLguY - mentalg@geocities.com
 *                    Rodolphe Ortalo - ortalo@laas.fr
 *                    Tristan Wibberley - bloater@ps.cus.umist.ac.uk
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: hide.c,v $
 * Revision 1.9  2000/03/19 19:32:46  ortalo
 * Some debugging and modifications (wrt OpenAmulet mainly).
 *
 * Revision 1.8  2000/03/13 22:02:55  ortalo
 * Committed new version of LibGWT corresponding to 0.0.2.
 * The event management API is probably more or less defined. The simplest
 * approach finally won. (I should have remembered: KISS!)
 *
 * Revision 1.7  1999/05/13 20:01:38  ortalo
 * New version of libgwt. Now using LibGII for input management.
 * Some drawing functions implemented. Visibility management should
 * be rather okay. Still some work to do, but now, your eyes can
 * look at some drawings... not only code. ;-)
 *
 * Revision 1.6  1998/11/17 15:13:28  tristan
 *
 * Changed my email address
 *
 * Revision 1.5  1998/09/02 02:21:45  tristan
 * Loadsa great stuff done. Visible/invalid regions,
 *  copy on move - fixed tt_region.c too!
 *
 * Revision 1.4  1998/08/23 18:57:10  ortalo
 * Minor editing (mainly comments).
 *
 * Revision 1.3  1998/08/16 18:40:55  ortalo
 * A new version, STILL IN VERY ALPHA STATE... (Be patient.)
 * (However, this version is a little better... :-)
 *
 * Revision 1.2  1998/08/11 22:10:07  ortalo
 * Incorporated the changes made by Tristan Wibberley. The code is
 * still in alpha development state.
 *
 * Revision 1.1  1998/07/09 18:38:39  ortalo
 * Initial integration of libgwt in the GGI repository.
 * This is experimental code, for your eyes only !
 * (Don't execute... ;-)
 *
 */

#include "internal.h"
#include "gwt_debug.h"

/**************************************************************************
 *                     GWT PUBLIC EXPORTED FUNCTIONS                      *
 **************************************************************************/

int gwtHide(gwt_window_t win)
{
  if (win->level == 0)  return 1;
  if (win->hidden == 1) return 0;
    
  win->hidden = 1;
  /* Update the implicitly hidden info. */
  gwt_implicitly_hidden_update(win);
  GWTDPRINT("GWT: Uncovering Parent win=%p\n", win);
  gwt_propagate_geometry_update(win->wparent);
  gwt_invalidate(win->wparent, win->geometry);
  GWTDPRINT("GWT: Uncovered Parent win=%p\n", win);

  return 0;
}

int gwtShow(gwt_window_t win)
{
  if (win->hidden == 0) return 0;

  win->hidden = 0;
  /* Update the implicitly hidden info. */
  gwt_implicitly_hidden_update(win);
  GWTDPRINT("GWT: Covering Parent win=%p\n", win);
  gwt_propagate_geometry_update(win->wparent);
  gwt_invalidate(win, win->geometry);
  GWTDPRINT("GWT: Covered Parent win=%p\n", win);
  
  return 0;
}

int gwtIsHidden(gwt_window_t win)
{
  return (win->hidden == 1);
}

int gwtIsVisible(gwt_window_t win)
{
  return ((win->implicitly_hidden == 0) && (win->hidden == 0));
}
